<!DOCTYPE html>
<html lang="en">
<head>
     <meta charset="UTF-8">
     <meta http-equiv="X-UA-Compatible" content="IE=edge">
     <meta name="viewport" content="width=device-width, initial-scale=1.0">
     <title>Quản Trị User</title>

     <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
     <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
     <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
     <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.15.3/css/all.min.css">
     <!-- Data Table-->
     <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
     <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
     <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
</head>
<body>
     <!--Vùng header-->
     <div class="container">
          <div class="text-center mt-3">
               <h2>F120 - Quản Trị Users</h2>
          </div>
          <div class="form-group">
               <button class="btn btn-success" id="btn-add-user"><i class="fa fa-plus"></i>&nbsp; New User</button>
          </div>
     </div>
     <!--Vùng User Datatable-->
     <div class="container">
          <table class="table table-bordered table-striped table-hover" id="user-table">   
               <thead>
                    <tr>
                         <th>Id</th>
                         <th>Firsname</th>
                         <th>Lastname</th>
                         <th>Country</th>
                         <th>Subject</th>
                         <th>Customer Type</th>
                         <th>Register Status</th>
                         <th>Action</th>
                    </tr>
               </thead>
          </table>
     </div>

     <!--Vùng modal-->
     <!--Tạo modal user-->
     <div class="modal fade" tabindex="-1" id="create-user-modal">
          <div class="modal-dialog">
            <div class="modal-content">
              <div class="modal-header">
                <h5 class="modal-title" id="h5-modal-title">Create new user</h5>
                <button class="close" data-dismiss="modal"> &times;</button>
              </div>
              <div class="modal-body">
               <form>
                    <div class="row form-group">
                         <label class="col-form-label col-sm-4" for="inp-create-firstname">Firstname</label>
                         <div class="col-sm-8">
                             <input type="text" id="inpt-create-firstname" placeholder="Firstname" class="form-control">
                         </div>
                    </div>
                    <div class="row form-group">
                         <label class="col-form-label col-sm-4" for="inp-create-lastname">Lastname</label>
                         <div class="col-sm-8">
                             <input type="text" id="inpt-create-lastname" placeholder="Lastname" class="form-control">
                         </div>
                    </div>
                    <div class="row form-group">
                         <label class="col-form-label col-sm-4" for="select-create-country">Country</label>
                         <div class="col-sm-8">
                             <select id="select-create-country" class="form-control">
                                   <option value="VN">Việt Nam</option>
                                   <option value="USA">USA</option>
                                   <option value="AUS">Australia</option>
                                   <option value="CAN">Canada</option>
                             </select>
                         </div>
                    </div>
                    <div class="row form-group">
                         <label class="col-form-label col-sm-4" for="select-create-customer-type">Customer Type</label>
                         <div class="col-sm-8">
                             <select id="select-create-customer-type" class="form-control">
                                   <option value="Standard">Standard</option>
                                   <option value="Gold">Gold</option>
                                   <option value="Premium">Premium</option>
                             </select>
                         </div>
                    </div>
                    <div class="row form-group">
                         <label class="col-form-label col-sm-4" for="inp-create-subject">Subject</label>
                         <div class="col-sm-8">
                             <input type="text" id="inp-create-subject" placeholder="Subject" class="form-control">
                         </div>
                    </div>
               </form>
              <div class="modal-footer">
                <button class="btn btn-primary" id="btn-create-user">Insert User</button>
                <button class="btn btn-secondary" id="btn-create-cancel" data-dismiss="modal">Cancel</button>
              </div>
            </div>
          </div>
          </div>
     </div>

     <!--Vùng modal-->
     <!--Tạo update user-->
     <div class="modal fade" tabindex="-1" id="create-update-user">
          <div class="modal-dialog">
            <div class="modal-content">
              <div class="modal-header">
                <h5 class="modal-title" id="h5-modal-title">Chi tiết User</h5>
                <button class="close" data-dismiss="modal"> &times;</button>
              </div>
              <div class="modal-body">
               <form>
                    <div class="row form-group">
                         <label class="col-form-label col-sm-4" for="inp-create-update-firstname">Firstname</label>
                         <div class="col-sm-8">
                             <input type="text" id="inpt-create-update-firstname" placeholder="Firstname" class="form-control">
                         </div>
                    </div>
                    <div class="row form-group">
                         <label class="col-form-label col-sm-4" for="inp-create-update-lastname">Lastname</label>
                         <div class="col-sm-8">
                             <input type="text" id="inpt-create-update-lastname" placeholder="Lastname" class="form-control">
                         </div>
                    </div>
                    <div class="row form-group">
                         <label class="col-form-label col-sm-4" for="select-create-update-country">Country</label>
                         <div class="col-sm-8">
                             <select id="select-create-update-country" class="form-control">
                                   <option value="VN">Việt Nam</option>
                                   <option value="USA">USA</option>
                                   <option value="AUS">Australia</option>
                                   <option value="CAN">Canada</option>
                             </select>
                         </div>
                    </div>
                    <div class="row form-group">
                         <label class="col-form-label col-sm-4" for="select-create-update-customer-type">Customer Type</label>
                         <div class="col-sm-8">
                             <select id="select-create-update-customer-type" class="form-control">
                                   <option value="Standard">Standard</option>
                                   <option value="Gold">Gold</option>
                                   <option value="Premium">Premium</option>
                             </select>
                         </div>
                    </div>
                    <div class="row form-group">
                         <label class="col-form-label col-sm-4" for="select-create-update-register-status">Register Status</label>
                         <div class="col-sm-8">
                             <select id="select-create-update-register-status" class="form-control">
                                   <option value="New">New</option>
                             </select>
                         </div>
                    </div>
                    <div class="row form-group">
                         <label class="col-form-label col-sm-4" for="inp-create-update-subject">Subject</label>
                         <div class="col-sm-8">
                             <input type="text" id="inp-create-update-subject" placeholder="Subject" class="form-control">
                         </div>
                    </div>
               </form>
              <div class="modal-footer">
                <button class="btn btn-primary" id="btn-create-update-user">Update User</button>
                <button class="btn btn-secondary" id="btn-create-cancel" data-dismiss="modal">Cancel</button>
              </div>
            </div>
          </div>
     </div>
     </div>
</body>
<script>
     "use strict";
     /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
     const gBASE_URL = "http://203.171.20.210:8080/crud-api/users/";
     const gCONTENT_TYPE = "application/json;charset=UTF-8";

     //biến toàn cục để lưu trữ id user đang được update hoặc delete. Mặc định = 0;
     var gUserId = 0;

     //biến mảng hằng số chứa danh sách tên các thuộc tính 
     const gUSER_COLS = ["id", "firstname", "lastname", "country", "subject", "customerType", "registerStatus", "action"];

     //biến mảng toàn cục định nghĩa chỉ số các cột trong mảng 
     const gUSER_ID_COL = 0;
     const gFIRST_NAME_COL = 1;
     const gLAST_NAME_COL = 2;
     const gCOUNTRY_COL = 3;
     const gSUBJECT_COL = 4;
     const gCUSTOMER_TYPE_COL = 5;
     const gREGISTER_STATUS_COL = 6;
     const gACTION_COL = 7;

     //khai báo datatable &mapping comlumns
     var gUserTable = $("#user-table").DataTable({
          columns:[
               {data: gUSER_COLS[gUSER_ID_COL]},
               {data: gUSER_COLS[gFIRST_NAME_COL]},
               {data: gUSER_COLS[gLAST_NAME_COL]},
               {data: gUSER_COLS[gCOUNTRY_COL]},
               {data: gUSER_COLS[gSUBJECT_COL]},
               {data: gUSER_COLS[gCUSTOMER_TYPE_COL]},
               {data: gUSER_COLS[gREGISTER_STATUS_COL]},
               {data: gUSER_COLS[gACTION_COL]},
          ], 
          columnDefs:[
               {
                     //định nghĩa lại cột action
                    targets: gACTION_COL,
                    defaultContent:`
                    <img class="edit-user" src="https://cdn0.iconfinder.com/data/icons/glyphpack/45/edit-alt-512.png" style="width: 20px;cursor:pointer;">
                    <img class="delete-user" src="https://cdn4.iconfinder.com/data/icons/complete-common-version-6-4/1024/trash-512.png" style="width: 20px;cursor:pointer;">
                    `
               }  
          ]
     });

     /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
     $(document).ready(function(){
          onPageLoading();
     });

     //1. gán sự kiện thêm mới user
     $("#btn-add-user").on("click", function(){
          onBtnAddUserClick(this);
     })

     //2. Gán sự kiện update - sửa 1 user
     $("#user-table").on("click", ".edit-user", function(){
          onBtnEditUserClick(this);
     });

     //3. Gán sự kiện Delete - xóa 1 user
     $("#user-table").on("click", ".delete-user", function(){
          onBtnDeleteUserClick(this);
     });

     //4. gán sự kiện cho nút insert User
     $("#btn-create-user").on("click", function(){
          onBtnInsertUserClick(this);
     });


     //5. Gán sự kiện cho nút update user
     $("#user-table").on("click", ".edit-user", function(){
          onBtnEditUserClick(this);
     })

     //6. hàm xử lý khi nút update user được nhấn
     $("#btn-create-update-user").on("click", function(){
          onBtnUpdateUserClick(this);
     });
     /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
     //hàm xử lý việc tải trang 
     function onPageLoading(){
          //load dữ liệu lên datatable
          getAllUser();
     }

     //hàm xử lý sự kiện khi icon edit được nhấn 
     function onBtnEditUserClick(paramEdit){
          //lưu thông tin user id đang được edit vào biến toàn cục 
          gUserId = getUserIdFromButton(paramEdit);
          console.log("UPDATE, Id của user tương ứng là: " + gUserId); 

           //loadd dữ liệu vào các trươngừ dữ liệu trong modal
           getUserById(gUserId);

           //hiện modal
           $("#create-update-user").modal("show");
     }

      //hàm xử lý sự kiện khi icon edit được nhấn 
      function onBtnDeleteUserClick(paramDelete){
          //lưu thông tin user id đang được edit vào biến toàn cục 
          gUserId = getUserIdFromButton(paramDelete);
          console.log("DELETE, Id của user tương ứng là: " + gUserId); 
     }

      //hàm xử lý việc thêm mới user
      function onBtnAddUserClick(){
          $("#create-user-modal").modal("show");
     }

     //hàm xử lý việc nút insert user được click
     function onBtnInsertUserClick(){
          var vIsertUserObj = {
               firstname: "", 
               lastname:"",
               country: "", 
               subject: "", 
               customerType: "" 
          }

          //B1: thu thập dữ liệu 
               readDataModalAddUser(vIsertUserObj);
          //B2: kiểm tra dữ liệu 
          var vCheckUser = validateUserData(vIsertUserObj);
          if(vCheckUser){
                //B3: Gọi sever
                $.ajax({
                    url: gBASE_URL,
                    type: "POST",
                    contentType: "application/json;charset=UTF-8",
                    data: JSON.stringify(vIsertUserObj),
                    success: function(res){
                         //ghi ra console
                         console.log(res);
                          //B4: xử lý hiển thị 
                          handleInsertUserSuccess();
                    }, 
                    error: function(ajaxContent){
                         console.log(ajaxContent.status);
                    }
                });
          }   
     }



     //hàm xử lý khi nút update click
     function onBtnUpdateUserClick(){
          var vUpdateUserObj = {
               firstname: "", 
               lastname:"",
               country: "", 
               subject: "", 
               customerType: "",
               registerStatus:""
          }

          //B1: thu thập thông tin từ form
               readDataUpdateUser(vUpdateUserObj);
          //B2: kiểm tra thông tin
               var vCheckFormEditUser = validateFormEditUser(vUpdateUserObj);
               if(vCheckFormEditUser){
                      //B3: gọi sever\
                    $.ajax({
                         url: gBASE_URL + gUserId,
                         type: "PUT", 
                         contentType: gCONTENT_TYPE,
                         data: JSON.stringify(vUpdateUserObj),
                         success: function(paramRes){
                               //B4: xử lý hiển thị 
                               handleUpdateUserSuccess();
                         },
                         error: function (paramErr) {
                              console.log(paramErr.status);
                          }
                    });
               }
         
     }
     /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/

     //hàm đọc thông tin từ form edit
     function readDataUpdateUser(paramEditUser){
          paramEditUser.firstname = $("#inpt-create-update-firstname").val().trim();
          paramEditUser.lastname = $("#inpt-create-update-lastname").val().trim();
          paramEditUser.country = $("#select-create-update-country").val();
          paramEditUser.customerType = $("#select-create-update-customer-type").val();
          paramEditUser.registerStatus = $("#select-create-update-register-status").val();
          paramEditUser.subject = $("#inp-create-update-subject").val().trim();
     }

     //hàm kiểm tra form edit
     function validateFormEditUser(paramEditUser){
          if(paramEditUser.firstname == ""){
               alert("Vui lòng nhập Firstname!!!");
               return false;
          }
          if(paramEditUser.lastname == ""){
               alert("Vui lòng nhập Lastname!!!");
               return false;
          }
          if(paramEditUser.subject == ""){
               alert("Vui lòng nhập Subject!!!");
               return false;
          }
          return true;
     }

     //hàm xử lý việc hiển thị thông tin thêm user
     function handleInsertUserSuccess(){
          alert("Thêm user thành công!");
          getAllUser();
          resertCreateUserForm();
          $("#create-user-modal").modal("hide");
     }

     //hàm xóa trắng form create user
     function resertCreateUserForm(pa){
          $("#inpt-create-firstname").val("");
         $("#inpt-create-lastname").val("");
           $("#select-create-country").val("VN");
           $("#select-create-customer-type").val("Standard");
          $("#inp-create-subject").val("");
     }
     // hàm gọi api để load dữ liệu lên bảng 
     function getAllUser(){
          $.ajax({
               url: gBASE_URL,
               type: "GET", 
               success: function(paramUser){
                    console.log(paramUser);
                    loadDataToUserTable(paramUser);
               },
               error: function(ajaxContent){
                    alert(ajaxContent.responseText);
               }
          });
     }

     //hàm load dữ liệu user lên bảng 
     function loadDataToUserTable(paramUser){
          gUserTable.clear();
          gUserTable.rows.add(paramUser);
          gUserTable.draw();
     }

     //hàm dựa vào button detail (edit or delete) xác định được id user
     function getUserIdFromButton(paramButton){
          var vTableRow = $(paramButton).parents("tr");
          var vUserRowData = gUserTable.row(vTableRow).data();
          return vUserRowData.id;
     }

     //hàm thu thập dữ liệu trên form model thêm user
     function readDataModalAddUser(paramInsertObj){
          paramInsertObj.firstname = $("#inpt-create-firstname").val().trim();
          paramInsertObj.lastname = $("#inpt-create-lastname").val().trim();
          paramInsertObj.country = $("#select-create-country").val();
          paramInsertObj.customerType = $("#select-create-customer-type").val();
          paramInsertObj.subject = $("#inp-create-subject").val().trim();
     }

     //hàm kiểm tra dữ liệu form modal thêm user
     function validateUserData(paramInsertObj){
          if(paramInsertObj.firstname == ""){
               alert("Vui lòng nhập Firstname!!!");
               return false;
          }
          if(paramInsertObj.lastname == ""){
               alert("Vui lòng nhập Lastname!!!");
               return false;
          }
          if(paramInsertObj.subject == ""){
               alert("Vui lòng nhập Subject!!!");
               return false;
          }
          return true;
     }

     //hàm hiẻn thị dữ liệu vào modal sửa
     function getUserById(paramUserId){
        $.ajax({
          url: gBASE_URL + paramUserId,
          type: "GET",
          success: function(paramUser){
               showUserDataToModal(paramUser);
          },
          error: function(paramErr){
               console.log(paramErr.status);
          }
        });
     }


     //hàm show dữ liệu lên form\
     function showUserDataToModal(paramUserId){
          $("#inpt-create-update-firstname").val(paramUserId.firstname);
          $("#inpt-create-update-lastname").val(paramUserId.lastname);
          $("#select-create-update-country").val(paramUserId.country);
          $("#select-create-update-customer-type").val(paramUserId.customerType);
          $("#select-create-update-register-status").val(paramUserId.registerStatus);
          $("#inp-create-update-subject").val(paramUserId.subject);
     }

     // hàm xử lý hiển thị front-end khi sửa User thành công
     function  handleUpdateUserSuccess(){
          alert("Update user thành công!");
          getAllUser();
          resertUpdateUserForm();
          $("#create-update-user").modal("hide");
     }

      // hàm xóa trắng form update user
      function resertUpdateUserForm(){
          $("#inpt-create-update-firstname").val("");
          $("#inpt-create-update-lastname").val("");
          $("#select-create-update-country").val("VN");
          $("#select-create-update-customer-type").val("Standard");
          $("#sselect-create-update-register-status").val("New");
          $("#inp-create-update-subject").val("");
      }
</script>
</html>